/*global enyo */
enyo.kind({
	name: "App",
	kind: "FittableRows",
	classes: "onyx app",
	components: [
		{kind: "onyx.Toolbar", classes: "enyo-unselectable", components: [{content: "Drag & Drop testbed"}]},
		{kind: "FittableColumns", fit: true, components: [
			{kind: "DragTarget", onDragDone: "dragDone"},
			{name: "list", kind: "DragSource", fit: true, onItemDrag: "avatarTrack", onItemDragCancel: "dragCancel", onItemDragFinish: "dragFinish"}
		]},
		{name: "avatar", kind: "Image", src: "icon.png", classes: "app-avatar", showing: false}
	],
	create: function() {
		this.inherited(arguments);
		this.makeData();
		this.$.list.setData(this.data);
	},
	// make a simple list
	makeData: function() {
		this.data = [];
		for (var i=0; i<50; i++) {
			this.data[i] = "Item [" + i + "]";
		}
	},
	avatarTrack: function(inSender, inEvent) {
		if (! this.$.avatar.getShowing()) {
			this.$.avatar.show();
		}
		this.$.avatar.setBounds({left: inEvent.pageX - 16, top: inEvent.pageY - 16});
	},
	hideAvatar: function() {
		console.log("hiding");
		this.$.avatar.hide();
	},
	dragCancel: function() {
		console.log("drag canceled");
		this.hideAvatar();
	},
	dragFinish: function() {
		console.log("drag finished");
		this.hideAvatar();
	},
	dragDone: function(inSender, inEvent) {
		var row = inEvent.row;
		//un-highlight row
		this.$.list.setItemHighlighted(-1);
		// remove the data from the source list and refresh
		this.hideAvatar();
		this.data.splice(row, 1);
		this.$.list.setCount(this.data.length);
		this.$.list.refresh();
	}
});