enyo.kind({
	name: "DragSource",
	kind: "List",
	handlers: {
		onSetupItem: "setupRow"
	},
	events: {
		onItemDrag: "",
		onItemDragFinish: "",
		onItemDragCancel: "",
	},
	published: {
		data: []
	},
	components: [
		{kind: "onyx.Item", classes: "enyo-unselectable item", content: "An Item",
			onhold: "itemMousehold", onrelease: "itemMouserelease",
			onmousedown: "itemDown",
			ondragstart: "itemDragStart", ondrag: "itemDrag", ondragfinish: "itemDragFinish"
		}
	],
	highlightRow: -1,
	create: function() {
		this.inherited(arguments);
		this.dataChanged();
	},
	dataChanged: function() {
		console.log("Setting count to "+this.data.length);
		this.setCount(this.data.length);
	},
	setupRow: function(inSender, inEvent) {
		//console.log("Building row "+inEvent.index);
		var d = this.data[inEvent.index];
		if (d) {
			this.$.item.setContent(d);
			return true;
		}
	},
	itemDown: function(inSender, inEvent) {
		// Without this, Chrome likes to display a text-selection cursor on drags
		// Safari still doesn't do the right thing here.
		inEvent.preventDefault(); 
	},
	itemMousehold: function(inSender, inEvent) {
		// indicate the row that's being dragged
		this.setItemHighlighted(inEvent.index);
		// show and track a drag avatar
		this.doItemDrag(inEvent);
	},
	itemMouserelease: function(inSender, inEvent) {
		this.setItemHighlighted(-1);
		this.doItemDragCancel();
	},
	// initiate a drag on a list item
	itemDragStart: function(inSender, inEvent) {
		// indicate we are dragging and store some drag info
		inEvent.dragInfo = {
			row: inEvent.index,
			content: this.data[inEvent.index]
		};
		// indicate the row that's being dragged
		this.setItemHighlighted(inEvent.index);
		// show and track a drag avatar
		this.doItemDrag(inEvent);
		return true;
	},
	itemDrag: function(inSender, inEvent) {
		this.doItemDrag(inEvent);
	},
	itemDragFinish: function(inSender, inEvent) {
		// indicate the row is no longer dragging
		this.setItemHighlighted(-1);
		// hide the avatar
		this.doItemDragFinish(inEvent);
	},
	setItemHighlighted: function(row) {
		var previous = this.highlightRow;
		this.highlightRow = row;
		if (previous !== -1) {
			this.prepareRow(previous);
			this.$.item.removeClass("item-selected");
			this.lockRow(previous);
		}
		if (row !== -1) {
			this.prepareRow(row);
			this.$.item.addClass("item-selected");
			this.lockRow(row);
		}
	},	
});
