enyo.kind({
	name: "DragTarget",
	kind: "FittableRows", 
	style: "border-right: 1px solid #333;", 
	components: [
		{content: "Drag Here!", classes: "enyo-unselectable drag-target", name: "target", ondragover: "dragOver", ondrop: "dragDrop", ondragout: "dragOut"},
		{kind: "enyo.Scroller", fit: true, classes: "enyo-unselectable", components: [
			{name: "dropList"}
		]}
	],
	events: {
		onDragDone: ""
	},
	dragOver: function(inSender, inEvent) {
		// if there is drag info, indicate the target is being dragged over
		if (inEvent.dragInfo !== undefined) {
			inSender.applyStyle("background-color", "lightblue");
		}
	},
	dragOut: function(inSender, inEvent) {
		// if there is drag info, indicate the target is no longer being dragged over
		if (inEvent.dragInfo !== undefined) {
			inSender.applyStyle("background-color", null);
		}
	},
	dragDrop: function(inSender, inEvent) {
		// if there is drag info, do a drop
		if (inEvent.dragInfo !== undefined) {
			inSender.applyStyle("background-color", null);
			var row = inEvent.dragInfo.row;
			var content = inEvent.dragInfo.content;
			// add to the drop list
			this.$.dropList.createComponent({kind: "onyx.Item", content: content, classes: "enyo-unselectable item"}).render();
			this.doDragDone({row: row});
		}
	}	
});
