DragFromList: Some drag & drop experiments
---------------------------
This started out as a straightforward port of the old Enyo1 DragFromList example, but I'm going to evolve it to try out some other things, in particular, interaction of other features with Drag&Drop.

What I've learned so far:
------------------------------
**Don't re-render a control in response to a dragStart event**
I was using List's renderRow() function to re-draw the row I was dragging (to highlight it), but that destroys and recreates the flyweight control (of course), and the drag events after that don't have a usable index value set.

The "right" way to do this is with prepareRow() and lockRow(), so you can set a class (or whatever) on that particular row in response to dragStart.

**Getting the cursor to do the right thing during drags is not trivial**
On Chrome, there's a tendency to set a text selection cursor, whenever you wouse-down over text (even if it's not actually selectable). calling preventDefault() on the event prevents that. It doesn't work on Safari, though.

**Fittables and Scroller can work oddly together**
I had something like this:
	FittableRows (app)
		FittableColumns (fit: true)
			FittableRows
				Scroller (fit: true)
				img (hidden)
And the Scroller was getting set to 0 height. Adding a Toolbar to the topmost FittableRows allowed the measurement to work correctly, and everything displayed properly.
